-- $LastChangedDate: 2008-09-02 20:29:21 -0400 (Tue, 02 Sep 2008) $
-- Dequeue and execute commands from the simulator's command queue.
-- See module.txt for documentation and pitfalls.

------------------------
-- CommandQueue class --
------------------------
CommandQueue = {
	cmdString = nil,
	cmdFields = nil,
	-- The name of the command is the first element:
	COMMAND_FIELD = 1,
	-- RESTART command field indexs:
	RESTART_FIELD_MISSION  = 2,
	RESTART_FIELD_AIRCRAFT = 3,
	RESTART_FIELD_LOCATION = 4,
	RESTART_FIELD_LAT      = 5,
	RESTART_FIELD_LON      = 6,
	RESTART_FIELD_ALT      = 7,
}

-- Get latest command (as Lua table) or nil.
function CommandQueue.GetCmdFields()
	local self = CommandQueue
	return self.cmdFields
end

-- Restart mission (see gui.cc).
function CommandQueue.Restart( cmdFields )
	local self = CommandQueue

	-- Remake player in case the user has chosen a different aircraft using GUI.
	local aircraftName = cmdFields[self.RESTART_FIELD_AIRCRAFT]
	Player.Make( sim.Aircraft.longNameTypeMap[aircraftName] )

	-- Restart mission.
	Mission.Reset()
end

-- Main function to dequeue/execute simulator commands.
function CommandQueue.Process()
	local self = CommandQueue

	-- Dequeue next command.
	self.cmdString = sim.Program:DequeueCommand()
	if ( self.cmdString ) then  -- if queue not empty
		-- Split command string into fields.
		self.cmdFields = SplitFields( self.cmdString, "," )
		
		-- For each kind of command.
		local cmd = self.cmdFields[1]
		if ( cmd == "RESTART" ) then
			CommandQueue.Restart( self.cmdFields )
		end
	end
end
