-- $LastChangedDate: 2008-09-02 20:29:21 -0400 (Tue, 02 Sep 2008) $
-- Basic Lua functions.
-- See module.txt for documentation and pitfalls.

-- Catenate two words, placing space if necessary.
function CatWords( s1, s2 )
	if ( s1 ~= "" ) then
		return s1 .. " " .. s2
	else
		return s2
	end
end

-- Split fields of a string.
function SplitFields( str, sep )
	-- This regex pattern needs a separator at end of string.
	if ( str[string.len(str)] ~= sep ) then
		str2 = string.format( "%s%s", str, sep )
		return {str2:match((str2:gsub("[^"..sep.."]*"..sep, "([^"..sep.."]*)"..sep)))}
	else
		return {str:match((str:gsub("[^"..sep.."]*"..sep, "([^"..sep.."]*)"..sep)))}
	end
end
