/*****************************************************************************
 * $LastChangedDate: 2008-08-27 19:45:17 -0400 (Wed, 27 Aug 2008) $
 * @file
 * @author	Jim E. Brooks  http://www.palomino3d.org
 * @brief	Collision-detection class.
 *//*
 * LEGAL:	COPYRIGHT (C) 2008 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE VERSION 2 (GPL 2).
 *****************************************************************************/

#ifndef COLLISION_COLLISION_HH
#define COLLISION_COLLISION_HH 1

#define GET_COLLISION() (Collision::GetInstance())

namespace collision {

////////////////////////////////////////////////////////////////////////////////
/// @brief Collision-detection class (Singleton).
///
class Collision
{
PREVENT_COPYING(Collision)
private:
                Collision( void );
                ~Collision();

public:
    CLASS_METHOD Collision& GetInstance( void )  // Singleton
	{
		if ( UX( msInstance == NULL ) )
			msInstance = new Collision;
		return *msInstance;
	}

	void						SetCollidable( shptr<Object> object, const bool collidable );
	pair<bool,shptr0<Object> >	IfCollision( shptr<Dyna> dyna );

private:
	typedef set<shptr<Object> > Collidables;
    CLASS_VAR Collision*	msInstance;
	Collidables				mCollidables;
};

} // namespace collision

#endif // COLLISION_COLLISION_HH
