/*****************************************************************************
 * $LastChangedDate: 2008-08-24 16:48:40 -0400 (Sun, 24 Aug 2008) $
 * @file
 * @author	Jim E. Brooks  http://www.palomino3d.org
 * @brief	Events for controlling a Craft.
 *//*
 * LEGAL:	COPYRIGHT (C) 2008 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE VERSION 2 (GPL 2).
 *****************************************************************************/

#ifndef CONTROL_EVENTS_HH
#define CONTROL_EVENTS_HH 1

#define CONTROL_EVENTS control::global::gEvents

#include "base/event.hh"
using namespace base;
#include "object/module.hh"
#include "object/craft.hh"
using namespace object;
#include "control/command.hh"

namespace control {

/// @brief Pairs a Craft with its Command.
struct CommandEvent
{
	CommandEvent( shptr<Craft> craft, shptr<Command> command )
	: mCraft(craft), mCommand(command) { }
	shptr<Craft>	mCraft;
	shptr<Command>	mCommand;
};

////////////////////////////////////////////////////////////////////////////////
/// @brief Events for controlling a Craft.
///
struct Events
{
	Event<CommandEvent>	mCommand;
};

#if CONTROL_MODULE_CC
namespace global { Events gEvents; }
#else
namespace global { extern Events gEvents; }
#endif

} // namespace control

#endif // CONTROL_EVENTS_HH
