/*****************************************************************************
 * $LastChangedDate: 2008-07-05 00:14:22 -0400 (Sat, 05 Jul 2008) $
 * @file
 * @author	Jim E. Brooks  http://www.palomino3d.org
 * @brief	OpenGL abstraction.
 *//*
 * LEGAL:	COPYRIGHT (C) 2008 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE VERSION 2 (GPL 2).
 *****************************************************************************/

#define GLUE_GFX_CC 1
#include "base/module.hh"
using namespace base;
#include "glue/module.hh"
#include "glue/gfx.hh"

namespace glue {

////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////  GFX  ///////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

/*****************************************************************************
 * Begin/end 2D drawing mode.
 *****************************************************************************/
void
GFX::Begin2D( const Rect<int>& rect )
{
ASSERT( not rect.IfZero() );
	glLineWidth( 1.0f );
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_LIGHTING );
	glDisable( GL_TEXTURE_2D );
	glEnable( GL_LINE_SMOOTH );
	glMatrixMode( GL_TEXTURE    ); glLoadIdentity();
	glMatrixMode( GL_PROJECTION ); glLoadIdentity();
	glMatrixMode( GL_MODELVIEW  ); glLoadIdentity();
	gluOrtho2D( rect.x1, rect.x2,
                rect.y1, rect.y2 );  // after the above
	glMatrixMode( GL_MODELVIEW  );
	glViewport( 0, 0, rect.x2, rect.y2 );
}

void
GFX::End2D( void )
{
	// NOP.  OSG will undo the mode changes.
}

} // namespace glue
