/*****************************************************************************
 * $LastChangedDate: 2008-05-18 10:32:59 -0400 (Sun, 18 May 2008) $
 * @file
 * @author	Jim E. Brooks  http://www.palomino3d.org
 * @brief	Main header file.
 * @namespace hud
 * @brief HUD module.
 *//*
 * LEGAL:   COPYRIGHT (C) 2007 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE VERSION 2 (GPL 2).
 *****************************************************************************/

#ifndef HUD_MODULE_HH
#define HUD_MODULE_HH 1

//------------------------------------------------------------------------------
// Coding convention for modules:
// - module.hh is the main header files that includes often-used header files.
// - Init() initializes the module (if applicable).
// - Start() starts the execution of a module (if applicable).

namespace hud {

typedef base::InitArgs InitArgs;

void Init( const InitArgs& initArgs );

void Start( void );

} // namespace hud

//------------------------------------------------------------------------------

#if DEBUG
#include "hud/typesig_defs.hh"
#endif
#include "hud/hud.hh"

#endif // HUD_MODULE_HH
