/*****************************************************************************
 * $LastChangedDate: 2008-06-24 23:07:05 -0400 (Tue, 24 Jun 2008) $
 * @file
 * @author	Jim E. Brooks  http://www.palomino3d.org
 * @brief	Misc functions.
 *//*
 * LEGAL:   COPYRIGHT (C) 2008 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE VERSION 2 (GPL 2).
 *****************************************************************************/

#ifndef PROGRAM_FUNCS_HH
#define PROGRAM_FUNCS_HH 1

#include "graph/light.hh"
using namespace graph;

namespace program {

shptr<Graph>
LoadModel( const CraftSpecs& craftSpecs, const bool loadCopy );

shptr<Light>
InsertLightIntoGraph( shptr<Graph> graph,
                      const uint lightNum,
                      const RGBA ambient,
                      const RGBA diffuse,
                      const RGBA specular );

} // namespace program

#endif // PROGRAM_FUNCS_HH
